from tkinter import *
from math import pi
from math import cos
from math import sin
from math import sqrt

ang=315 #angle de début en degrés
ray=150 #rayon du cercle dans lequel est inscrit le carré
cot=sqrt(2)*ray #côté des carrés du cube
couleurs=["yellow","light blue","red","pink"] #couleurs des faces du cube

def dessine(rd,cd,apd,coul):
    x1=cos(apd)*rd+rd+100
    y1=100+rd/3-sin(apd)*rd/3
    x2=cos(apd+pi/2)*rd+rd+100
    y2=100+rd/3-sin(apd+pi/2)*rd/3
    x3,y3=x2,y2+cd
    x4,y4=x1,y1+cd
    can.create_polygon(x1,y1,x2,y2,x3,y3,x4,y4,x1,y1,fill=coul)

def tourne(r,c,a):
    global ang
    global couleurs
    can.delete(ALL)
    ap=2*pi*a/360
    t=a/45
    if t>=7 or t<1:
        c1,a1=couleurs[0],ap
        c2,a2=couleurs[1],ap+pi/2
        c3,a3=couleurs[2],ap+pi
        c4,a4=couleurs[3],ap+3*pi/2
    elif t>=1 and t<3:
        c1,a1=couleurs[3],ap+3*pi/2
        c2,a2=couleurs[0],ap
        c3,a3=couleurs[1],ap+pi/2
        c4,a4=couleurs[2],ap+pi
    elif t>=3 and t<5:
        c1,a1=couleurs[2],ap+pi
        c2,a2=couleurs[3],ap+3*pi/2
        c3,a3=couleurs[0],ap
        c4,a4=couleurs[1],ap+pi/2
    elif t>=5 and t<7:
        c1,a1=couleurs[1],ap+pi/2
        c2,a2=couleurs[2],ap+pi
        c3,a3=couleurs[3],ap+3*pi/2
        c4,a4=couleurs[0],ap
    dessine(r,c,a1,c1)
    dessine(r,c,a2,c2)
    dessine(r,c,a3,c3)
    dessine(r,c,a4,c4)
    ang=ang+1
    ang=ang%360

def debut():
    global ang
    global  ray
    global cot
    tourne(ray,cot,ang)
    fen.after(25,debut)

fen=Tk()
fen.title("Cube giratoire en couleurs")
can=Canvas(fen,width=500,height=500,bg="black")
can.pack(side=TOP)
b1=Button(fen,text="Démarrer",command=debut)
b1.pack(side=LEFT)
b2=Button(fen,text="Quitter",command=fen.destroy)
b2.pack(side=RIGHT)

fen.mainloop()
